
/**
** Gregor Richter
 ** example main.c
 */
 
#include <avr/interrupt.h>
#include <inttypes.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/sleep.h>
#include <util/delay.h>

#include "uart.h"
#include "atkeyb.h"

#define F_CPU 16000000UL

int main(void)
{
	uart_init();
	uart_put_string("\nStart...\n");
	
	atkeyb_init();
	
	sei();
	
	atkeyb_Send(0xFF);
	atkeyb_set_led(0b111);
	
	
	atkeyb_Send(0xF3);
	atkeyb_Send(0x00);
	
	
	uint8_t temp;
	
	
	
	while(1){
		if(atkeyb_buffcnt != 0)
		{
			temp = atkeyb_getchar();
		}
		
		switch(temp)
		{
			case 0:
			break;
			
			case 1: //F1
				atkeyb_Send(0xF5); //Disable
				uart_put_string("\nKB Disable for 5 sec\n");
				_delay_ms(5000);
				atkeyb_Send(0xF4); //Enable
				uart_put_string("KB Enable\n");
			break;

			case 2: //F2
				uart_put_string("\nKB set fast typematic rate\n");
				atkeyb_Send(0xF3);
				atkeyb_Send(0x00);
			break;
			
			case 3: //F3
				uart_put_string("\nKB reset\n");
				atkeyb_Send(0xFF);
			break;
			
			case 4: //F4
				atkeyb_Send(0xF5); //Disable
				uart_put_string("\n!LED SHOW!^^\n");
				for(uint8_t i = 0; i < 5; i++)
				{
					atkeyb_set_led(0b010);
					_delay_ms(100);
					atkeyb_set_led(0b100);
					_delay_ms(100);
					atkeyb_set_led(0b001);
					_delay_ms(100);
				}
				for(uint8_t i = 0; i < 5; i++)
				{
					atkeyb_set_led(0b011);
					_delay_ms(150);
					atkeyb_set_led(0b100);
					_delay_ms(150);
				}
				atkeyb_Send(0xF4); //Enable
			break;
			
			default:
				uart_put_char(temp);
				
		}
		if(0x29 < temp < 0x38)
			atkeyb_set_led(temp-0x30);
		
		temp = 0;
	}
	
}